#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		fpcopt		-k"--build-id"
%global		ppcname		ppcx64
%global		fpcarchname	%{_arch}
#-----------------------------------------------------------------------------
Name		:	fpc
Version		:	3.2.2
Release		:	17.0.18.rel%{?dist}
Summary		:	Free Pascal Compiler
 
Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+ and LGPLv2+ with exceptions
URL		:	http://www.freepascal.org/
			#ftp://ftp.freepascal.org/pub/fpc/dist/

Source0		:	%{name}build-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	fpc
BuildRequires	:	glibc
BuildRequires	:	make

#-----------------------------------------------------------------------------
%description
Free Pascal is a free 32/64bit Pascal Compiler. It comes with a run-time
library and is fully compatible with Turbo Pascal 7.0 and nearly Delphi
compatible. Some extensions are added to the language, like function
overloading and generics. Shared libraries can be linked. This package
contains the command-line compiler and utilities. Provided units are the
runtime library (RTL), free component library (FCL) and packages.
 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}.cfg
%{_bindir}/*
%{_libdir}/%{name}/%{version}/ppcx64
%{_libdir}/%{name}/%{version}/samplecfg
%{_libdir}/libpas2jslib.so
%{_libdir}/%{name}/%{version}/units/%{_arch}-linux/*/*.o
%{_libdir}/%{name}/%{version}/units/%{_arch}-linux/*/*.ppu
%{_libdir}/%{name}/%{version}/units/%{_arch}-linux/*/*.rsj
%{_libdir}/%{name}/%{version}/units/%{_arch}-linux/*/*.fpc
%{_libdir}/%{name}/%{version}/fpmkinst/%{_arch}-linux/*.fpm
%{_libdir}/%{name}/%{version}/msg/*.msg
%{_libdir}/%{name}/lexyacc/*.cod
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/*.5.gz

#=============================================================================
%package		doc

Summary		:	Free Pascal Compiler - documentation and examples

Buildarch	:	noarch

Requires	:	%{name}	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		doc
The fpc-doc package contains the documentation (in pdf format) 
and examples of Free Pascal.
 

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/%{name}-%{version}/*/*

#=============================================================================
%package		src

Summary		:	Free Pascal Compiler - sources and examples

Requires	:	%{name}	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		src
The fpc-src package contains the sources of Free Pascal. 
for documentation, example or automatical-code generation purposes.
 

#-----------------------------------------------------------------------------
%files			src
%{_datadir}/fpcsrc/

#=============================================================================
%prep
%setup -q -n %{name}build-%{version}

#-----------------------------------------------------------------------------
#building application
%build

pushd	fpcsrc
FPCDIR=""
NEWPP=`pwd`/compiler/%{ppcname}

%{__make}					\
	OPT='%{fpcopt}'				\
	compiler_cycle				\

%{__make}					\
	FPC=${NEWPP}				\
	OPT='%{fpcopt}'				\
	rtl_clean rtl_smart			\
	packages_smart				\
	utils_all

popd	
#-----------------------------------------------------------------------------

%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

pushd	fpcsrc
FPCDIR=""
NEWPP=`pwd`/compiler/%{ppcname}
NEWFPCMAKE=$(pwd)/utils/fpcm/bin/%{fpcarchname}-linux/fpcmake
INSTALLOPTS="								\
	-j1								\
	FPC=${NEWPP}							\
	FPCMAKE=${NEWFPCMAKE}						\
	INSTALL_PREFIX=%{buildroot}%{_prefix}				\
	INSTALL_BINDIR=%{buildroot}%{_bindir}				\
	INSTALL_LIBDIR=%{buildroot}%{_libdir}				\
	INSTALL_DOCDIR=%{buildroot}%{_defaultdocdir}			\
	INSTALL_MANDIR=%{buildroot}%{_mandir}				\
	INSTALL_EXAMPLEDIR=%{buildroot}%{_defaultdocdir}/examples	\
	INSTALL_BASEDIR=%{buildroot}%{_libdir}/%{name}/%{version}	\
	"


%{__make}								\
	${INSTALLOPTS}							\
	compiler_distinstall						\
	rtl_distinstall							\
	packages_distinstall						\
	utils_distinstall
popd

pushd	install

%{__make}								\
	-C man								\
	${INSTALLOPTS}
popd


%{buildroot}%{_bindir}/fpcmkcfg				\
	-p						\
	-d "basepath=/usr/lib/fpc/\$fpcversion"		\
	-d "sharepath=/usr/lib/fpc/\$fpcversion"	\
	-o %{buildroot}%{_sysconfdir}/fpc.cfg


#create compiler architecture link
%{__ln_s} -f						\
	../../%{_libdir}/%{name}/%{version}/%{ppcname}	\
	%{buildroot}%{_bindir}/%{ppcname}

#install the example files
%{__mkdir_p}	%{buildroot}%{_datadir}/fpcsrc
%{__cp} -a						\
	fpcsrc/rtl					\
	fpcsrc/packages					\
	%{buildroot}%{_datadir}/fpcsrc/

#-----------------------------------------------------------------------------
%changelog
